/* $RCSfile: $
 * $Revision: $ $Date: $
 * Auth: Jochen Fritz (jfritz@steptools.com)
 * 
 * Copyright (c) 1991-2013 by STEP Tools Inc. 
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and
 * its documentation is hereby granted, provided that this copyright
 * notice and license appear on all copies of the software.
 * 
 * STEP TOOLS MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE
 * SUITABILITY OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING
 * BUT NOT LIMITED TO THE IMPLIED WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT. STEP TOOLS
 * SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A
 * RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS
 * DERIVATIVES.
 */

// Load some JavaScript into the browser
function include(js) {
    var scr = document.createElement("script");
    scr.src = js;
//    var cur_scr = document.currentScript;

    var head = document.getElementsByTagName("head")[0];
    head.appendChild(scr);
    
}

function open_file_read(filename) {
    console.log ("Reading file: "+filename);
    
    // Synchronous read of the entire file.  We should update this at some
    // point to be async

    var req = new XMLHttpRequest();
    req.overrideMimeType("text/plain");

    // req.addEventListener("progress", function(ev) {
    // 	set_text(req);
    // 	console.log ("Progress: "+ev.loaded);
    // });

    // req.addEventListener("load", function(ev) {
    // 	set_text(req);
    // 	console.log ("Load complete");
    // });
    
    req.open("GET", filename, false);
    req.send();

//    console.log ("Done Reading file: "+filename);
//    console.log ("response="+req.responseText);
    
    return req.responseText;
}

function close_file_read(stream) {}

function read_data(stream, sz) {
    return stream;
}

function open_file_write(filename)
{
    return {path: filename, data: ""};   
}

function close_file_write(stream)
{
    var req = new XMLHttpRequest();
    req.overrideMimeType("text/plain");

    req.open("PUT", stream.path, false);
    req.send(stream.data);
    
}

function write(stream, str)
{    
    stream.data += str;
}

include ("P21Wrapper.js");
include ("P21Lexer.js");
include ("P21Parse.js");
include ("P21Model.js");
include ("P21Reader.js");
